<template lang='pug'>
  section
    .container
      .wrapper
        BaseText.title.space-mdl(size='text-bg' weight='weight600') Производство
        .container-first
          ProductionInputs(:typeOfBiorobot.sync = 'typeOfBiorobot', :typeOfStabilizer.sync = 'typeOfStabilizer')
          BaseButton(
            size='big'
            skin='orange-not-filled'
            @click='product'
            :disabled='!isAllDetailsEnough'
          ) Произвести биоробота
        .container-second
          ProductionDetails(:detail = 'details[0]', :color.sync = 'color')
          ProductionDetails(:detail = 'details[1]', :color.sync = 'color')
          ProductionDetails(:detail = 'details[2]', :color.sync = 'color').production-detail-space-bottom
          ProductionTextNotEnoughDetails
        .container-third
          ProductionRobot(:typeOfBiorobot = 'typeOfBiorobot', :typeOfStabilizer = 'typeOfStabilizer', :color = 'color')
      ModalProduction(
        v-if='isShowModal'
        isShowModal=isShowModal
        @onClose='onClose'
      )
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'

import { PurseModule } from '../../store/modules/purse'
import { ProductionModule } from '../../store/modules/production/index'
import ProductionInputs from './ProductionInputs.vue'
import BaseButton from '../BaseButton.vue'
import BaseText from '../BaseText.vue'
import ProductionDetails from './ProductionDetails.vue'
import ProductionTextNotEnoughDetails from './ProductionTextNotEnoughDetails.vue'
import ProductionRobot from './ProductionRobot.vue'
import ModalProduction from '../ModalProduction.vue'

@Component({
  components: {
    ProductionInputs,
    ProductionDetails,
    ProductionTextNotEnoughDetails,
    ProductionRobot,
    ModalProduction,
    BaseButton,
    BaseText
  }
})
export default class Production extends Vue {
  isShowModal: boolean = false
  typeOfBiorobot: string = 'front'
  typeOfStabilizer: string = 'male'
  color: string = 'black'

  get details () {
    return ProductionModule.details
  }

  get coins (): number {
    return PurseModule.coins
  }

  get isAllDetailsEnough (): boolean {
    if (this.coins < 10) {
      return false
    }
    for (const i in this.details) {
      if (this.details[i].installed.filter((j: boolean) => j === true).length !== this.details[i].need) {
        return false
      }
    }
    return true
  }

  created () {
    ProductionModule.zeroOutInstalled()
    this.typeOfBiorobot = 'front'
    this.typeOfStabilizer = 'male'
    this.color = 'black'
  }

  onClose () {
    this.isShowModal = false
    this.color = 'black'
  }

  product () {
    PurseModule.subtractCoins(10)
    ProductionModule.zeroOutInstalled()
    ProductionModule.zeroOutQuantityProduction()

    this.color = 'colored'
    this.isShowModal = true
  }
}
</script>

<style lang = 'scss' scoped>
@import '../../assets/styles/config/variables.scss';

.wrapper {
  display: grid;
  grid-template-columns: repeat(8, 1fr);
  column-gap: 24px;
}

.title {
  grid-column: 2 / 4;
  font-size: 32px;
  line-height: 72px;
}

.container-first {
  grid-column: 2 / 4;
}

.container-second {
  grid-column: 4 / 6;
  margin-top: 4px;
}

.container-third {
  grid-column: 6 / 8;
}
</style>
